###################################################################
## This file holds common functions for DOSprompt                ##
## Feel free to copy and use any of these functions and classes! ##
###################################################################

version = '2.1a1'

import config, os, string
def dos_path(path, with_letter=False):
    if config.home_to_users:
        tmp_path = path.split('/')
        if tmp_path[1] == "home": tmp_path[1] = 'Users' # this eliminates bizarre name changes in folders other that /home/ like /some/thing/home
        path = '/'.join(tmp_path)
    if config.bin_to_sys32 and len(path.split('/')) > 1:
        tmp_path = path.split('/')
        if tmp_path[1:3] == ['usr', 'bin']: tmp_path = ['/Windows', 'System32'] + tmp_path[3:]
        path = '/'.join(tmp_path)
    if with_letter:
        cwd = path # the Current Working Directory

        # calculate a drive letter
        if cwd.startswith("/media/") or cwd.startswith("/mnt/"): # Common mount locations, so assumed removeable media
            mounts = os.listdir("/media/") + os.listdir("/mnt/")
            drive = cwd.split("/")[2]
            drive = string.letters[mounts.index(drive) + 4].upper()
        else: # anywhere else, we'll assume that it is C
            drive = "C" 
        path = path.split('/')
        path[1] = drive + ':'
        path.pop(0)
        path.pop(1)
        path = '\\'.join(path)
    return path
    
def unix_path(path, convert_letter=False):
    if len('/'.join(path.split('\\')).split('/')) > 2:
        if config.home_to_users:
            tmp_path = path.split('\\')
            tmp_path = '/'.join(tmp_path).split('/')
            if tmp_path[1] == "Users": tmp_path[1] = 'home'
            path = '/'.join(tmp_path)
        if config.bin_to_sys32 and len(path.split('/')) > 1:
            tmp_path = path.split('/')
            if tmp_path[1:3] == ['Windows', 'System32']: tmp_path = ['usr', 'bin'] + tmp_path[3:]
            path = '/'.join(tmp_path)
    if convert_letter and not path.startswith('/') and not path.startswith('\\'):
        tmp_path = path
        if not tmp_path.startswith('C:') and not tmp_path.startswith('/') and not tmp_path.startswith('\\') and ':' in tmp_path:
            mounts = os.listdir('/media/') + os.listdir("/mnt")
            drive = tmp_path.split(':')[0]
            try: drive_path = '/media/' + mounts[string.letters.index(drive.lower()) - 4]
            except IndexError: raise OSError('Drive letter could not be converted')
            path = drive_path + '/'.join(tmp_path.split('/')[1:])
        elif tmp_path.startswith('C:'):
            
            path = '/' + '/'.join(tmp_path.split('/')[1:])
    return path


def my_import(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod
